#ifndef _SHMAC_PTHREAD_CORE_TQ_H_
#define _SHMAC_PTHREAD_CORE_TQ_H_

#include "sched/sched.h"

void 	core_tq_push(unsigned int core_num, task_t *item, enum lock_mode lm);

int 	core_tq_pop_first_inactive(enum lock_mode lm, task_t **popped_task);

task_t *core_tq_update_current();
void    core_tq_force_current(task_t * new_current);

void 	core_tq_update_running_task(enum lock_mode lm, task_t *task, int old_policy);
void 	core_tq_update_blocked_task(enum lock_mode lm, task_t *task);

task_t *core_tq_get_current();
void	core_tq_remove_current();

unsigned int core_tq_size(unsigned int core_num, int sched_policy);

void    core_tq_block_current(enum lock_mode lm, enum task_block_reason reason);
void    core_tq_unblock_tasks(enum lock_mode lm);

int 	should_context_switch();

#if (defined(DEBUG) || defined(WARNINGS))
void 	pt(task_t *t);
void 	core_tq_print(unsigned int core_num);
#endif

#endif
