#include <stdlib.h>
#include "linked_list.h"


int linked_list_init(linkedlist_t *ll)
{
	ll->head	= NULL;
	ll->tail	= NULL;
	ll->count	= 0;

	return 1;
}

linkedlist_item_t *linked_list_head(linkedlist_t *ll)
{
	return (ll != NULL && ll->head != NULL)
		? ll->head
		: NULL;
}

linkedlist_item_t *linked_list_tail(linkedlist_t *ll)
{
	return (ll != NULL && ll->tail != NULL)
		? ll->tail
		: NULL;
}

linkedlist_item_t *linked_list_pop(linkedlist_t *ll)
{
	if (ll != NULL && ll->head != NULL) {
		void *ptr = ll->head;
		ll->head = ll->head->next;
		ll->count--;

		if (ll->head == NULL) {
			ll->tail = NULL;
		}

		return ptr;
	}

	return NULL;
}
int linked_list_push(linkedlist_t *ll, void *value)
{
	if (ll != NULL) {
		linkedlist_item_t *new_item = (linkedlist_item_t *)malloc(sizeof(linkedlist_item_t));

		if (new_item != NULL) {
			new_item->value = value;
			return linked_list_push_item(ll, new_item);
		} else {
			return 0;
		}
	}

	return 0;
}

int linked_list_push_item(linkedlist_t *ll, linkedlist_item_t *item)
{
	if (ll != NULL && item != NULL) {
		item->prev = ll->tail;
		item->next = NULL;

		if (ll->head == NULL) {
			ll->head = item;
		}

		if (ll->tail != NULL) {
			ll->tail->next = item;
		}

		ll->tail = item;
		ll->count++;

		return 1;
	}

	return 0;
}

int linked_list_remove(linkedlist_t *ll, linkedlist_item_t *ll_item)
{
	if (ll_item == NULL) {
		return 0;
	}

	// item not in list
	if (ll_item->prev == NULL && ll_item->next == NULL && ll->head != ll_item) {
		return 0;
	}

	// item is the only one in the list
	if (ll->head == ll->tail && ll->head == ll_item) {
		ll->head = NULL;
		ll->tail = NULL;
		ll->count = 0;
		return 1;
	}

	if (ll->head == ll_item) {
		ll->head = ll_item->next;
	}

	if (ll->tail == ll_item) {
		ll->tail = ll_item->prev;
	}

	if (ll_item->prev != NULL) {
		ll_item->prev->next = ll_item->next;
	}

	if (ll_item->next != NULL) {
		ll_item->next->prev = ll_item->prev;
	}

	ll_item->prev = NULL;
	ll_item->next = NULL;

	ll->count--;

	return 1;
}

unsigned int linked_list_size(linkedlist_t *ll)
{
	return (ll != NULL) ? ll->count : 0;
}
