#ifndef _SHMAC_PTHREADS_DEBUG_H_
#define _SHMAC_PTHREADS_DEBUG_H_

#include <stdio.h>
#include <pthread.h>
#include "shmac/shmac.h"
#include "shmac/mutex.h"

#ifdef DEBUG
#define debug(str, ...) \
	{ \
		extern shmac_mutex_t debug_mutex; \
		lock_mutex(&debug_mutex); \
		printf("[%u] DEBUG %s:%u (%s): " str "\n", \
			(unsigned int)*TILEREG_CPUID, __FILE__, __LINE__, __FUNCTION__, ##__VA_ARGS__); \
		unlock_mutex(&debug_mutex); \
	}
#else
#define debug(...)
#endif



#ifdef WARNINGS

#define warn(str, ...) \
	{ \
		extern shmac_mutex_t debug_mutex; \
		lock_mutex(&debug_mutex); \
		printf("[%u] WARNING %s:%u (%s): " str "\n", \
			(unsigned int)*TILEREG_CPUID, __FILE__, __LINE__, __FUNCTION__, ##__VA_ARGS__); \
		unlock_mutex(&debug_mutex); \
	}
#else
#define warn(...)
#endif

#endif // H-guard
