#include <pthread.h>
#include <errno.h>


int pthread_attr_getdetachstate(const pthread_attr_t *attr, int *detachstate)
{
	if (attr != NULL && detachstate != NULL) {
		*detachstate = attr->detachstate;
		return 0;
	}

	errno = EINVAL;
	return EINVAL;
}

int pthread_attr_setdetachstate(pthread_attr_t *attr, int detachstate)
{
	if (attr != NULL && detachstate != 0) {
		if (detachstate != PTHREAD_CREATE_DETACHED &&
			detachstate != PTHREAD_CREATE_JOINABLE)
		{
			errno = EINVAL;
			return EINVAL;
		}

		attr->detachstate = detachstate;
		return 0;
	}

	errno = EINVAL;
	return EINVAL;
}