#include <pthread.h>
#include <errno.h>

int pthread_attr_setinheritsched(pthread_attr_t *attr,
    int inheritsched)
{
	if (attr != NULL) {
		if (inheritsched == PTHREAD_INHERIT_SCHED ||
				inheritsched == PTHREAD_EXPLICIT_SCHED) {
			attr->inheritsched = inheritsched;
			return 0;
		} else {
			errno = ENOTSUP;
			return ENOTSUP;
		}
	}

	errno = EINVAL;
	return EINVAL;
}

int pthread_attr_getinheritsched(const pthread_attr_t *attr,
    int *inheritsched)
{
	if (attr != NULL) {
		*inheritsched = attr->inheritsched;
		return 0;
	}

	errno = EINVAL;
	return EINVAL;
}
