#include <pthread.h>
#include <errno.h>


int pthread_attr_setschedparam(pthread_attr_t *attr,
    const struct sched_param *param)
{
	if (attr != NULL && param != NULL) {
		attr->schedparam = *param;

		// clamp to [0-100]
		int *val = &attr->schedparam.sched_priority;
		*val = *val < 0 ? 0 : (*val > 100 ? 100 : *val);

		return 0;
	}

	errno = EINVAL;
	return EINVAL;
}

int pthread_attr_getschedparam(const pthread_attr_t *attr,
    struct sched_param *param)
{
	if (attr != NULL) {
		*param = attr->schedparam;
		return 0;
	}

	errno = EINVAL;
	return EINVAL;
}
