#include <pthread.h>
#include <errno.h>


int pthread_attr_setschedpolicy(pthread_attr_t *attr, int policy)
{
	if (attr != NULL) {
		if (policy == SCHED_FIFO ||
			policy == SCHED_RR ||
			policy == SCHED_OTHER)
		{
			attr->schedpolicy = policy;
			return 0;
		} else {
			errno = ENOTSUP;
			return ENOTSUP;
		}
	}

	errno = EINVAL;
	return EINVAL;
}

int pthread_attr_getschedpolicy(const pthread_attr_t *attr,
    int *policy)
{
	if (attr != NULL) {
		*policy = attr->schedpolicy;
	}

	errno = EINVAL;
	return EINVAL;
}
