#include <stdlib.h>
#include <errno.h>
#include <pthread.h>


int pthread_attr_setscope(pthread_attr_t *attr, int contentionscope)
{
	if (attr != NULL) {
		if (contentionscope == PTHREAD_SCOPE_SYSTEM ||
				contentionscope == PTHREAD_SCOPE_PROCESS) {
			attr->contentionscope = contentionscope;
			return 0;
		} else {
			errno = EINVAL;
			return EINVAL;
		}
	}

	errno = EINVAL;
	return EINVAL;
}

int pthread_attr_getscope(const pthread_attr_t *attr,
    int *contentionscope)
{
	if (attr != NULL) {
		*contentionscope = attr->contentionscope;
		return 0;
	}

	return EINVAL;
}
