#include <pthread.h>
#include <errno.h>

#include "../sched/sched.h" // for PTHREAD_STACK_MIN

int pthread_attr_setstacksize(pthread_attr_t *attr, size_t stacksize)
{
	if (attr != NULL) {
		attr->stacksize = (stacksize == 0) ? PTHREAD_STACK_MIN : stacksize;
		return 0;
	}

	errno = EINVAL;
	return EINVAL;
}

int pthread_attr_getstacksize(const pthread_attr_t *attr,
    size_t *stacksize)
{
	if (attr != NULL) {
		*stacksize = attr->stacksize;
		return 0;
	}

	errno = EINVAL;
	return EINVAL;
}
