#ifdef _POSIX_BARRIERS

#include <pthread.h>
#include <errno.h>

int pthread_barrierattr_init(pthread_barrierattr_t *attr)
{
    if (attr == NULL) {
        errno = EINVAL;
        return EINVAL;
    }

    attr->is_initialized = 1;
#if defined(_POSIX_THREAD_PROCESS_SHARED)
    attr->process_shared = PTHREAD_PROCESS_SHARED;
#endif

    return 0;
}

int pthread_barrierattr_destroy(pthread_barrierattr_t *attr)
{
    if (attr == NULL) {
        errno = EINVAL;
        return EINVAL;
    }

    attr->is_initialized = 0;
    return 0;
}

#endif
