#include <pthread.h>
#include <errno.h>

int pthread_barrierattr_getpshared(const pthread_barrierattr_t *
       restrict attr, int *restrict pshared)
{
#if defined(_POSIX_THREAD_PROCESS_SHARED)
    if (attr == NULL || pshared == NULL) {
        errno = EINVAL;
        return EINVAL;
    }

    *pshared = attr->process_shared;
#endif

    return 0;
}

int pthread_barrierattr_setpshared(pthread_barrierattr_t *attr,
       int pshared)
{
#if defined(_POSIX_THREAD_PROCESS_SHARED)
    if (attr == NULL || (pshared != PTHREAD_PROCESS_SHARED &&
                pshared != PTHREAD_PROCESS_PRIVATE))
    {
        errno = EINVAL;
        return EINVAL;
    }

    attr->process_shared = pshared;
#endif

    return 0;
}
