#include <errno.h>
#include <pthread.h>

#include "../sched/sched.h"
#include "../global_tq.h"

int pthread_cancel(pthread_t t)
{
	task_t *task = global_tq_find(t);

	if (task != NULL) {
		switch (task->state) {
			case QUEUED:
			case RUNNING:
			case BLOCKED:
				task->state = CANCEL_PENDING;
				return 0;
			case FINISHED:
			case DEQUEUED:
			case REAPED:
			case CANCEL_PENDING:
			case CANCELED:
				return 0;
		}
	}

	errno = ESRCH;
	return ESRCH;
}
