#include <pthread.h>
#include <errno.h>


int pthread_condattr_init(pthread_condattr_t *attr)
{
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

#if defined(_POSIX_THREAD_PROCESS_SHARED)
	attr->process_shared = PTHREAD_PROCESS_SHARED;
#endif
	attr->is_initialized = 1;

	return 0;
}

int pthread_condattr_destroy(pthread_condattr_t *attr)
{
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	attr->is_initialized = 0;
	return 0;
}
