#include <pthread.h>
#include <errno.h>


int pthread_condattr_getpshared(const pthread_condattr_t *attr,
    int *pshared)
{
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

#if defined(_POSIX_THREAD_PROCESS_SHARED)
	*pshared = attr->process_shared;
#endif
	return 0;
}

int pthread_condattr_setpshared(pthread_condattr_t *attr,
    int pshared)
{
#if defined(_POSIX_THREAD_PROCESS_SHARED)
	if (attr == NULL || (
			pshared != PTHREAD_PROCESS_SHARED &&
			pshared != PTHREAD_PROCESS_PRIVATE)) {
		errno = EINVAL;
		return EINVAL;
	}

	attr->process_shared = pshared;
#endif

	return 0;
}
