#include <pthread.h>
#include <errno.h>

#include "../sched/sched.h"
#include "../core.h"
#include "../global_tq.h"

int	pthread_detach(pthread_t __pthread)
{
    task_t *my_task = global_tq_find(__pthread);
    if (my_task== NULL) {
        errno = ESRCH;
        return ESRCH;
    }

    // for this to be non-racy and completely safe, we must lock
    // whichever core the task is being run on.
    core_lock(my_task->cpu_no, LOCK);

    // too late!
    if (my_task->state >= FINISHED) {
        errno = EINVAL;
        core_unlock(my_task->cpu_no, 1);
        return EINVAL;
    }

    my_task->attrs.detachstate = PTHREAD_CREATE_DETACHED;
    core_unlock(my_task->cpu_no, 1);

    return 0;
}
