#include <pthread.h>
#include <errno.h>


int pthread_mutexattr_init(pthread_mutexattr_t *attr)
{
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	attr->is_initialized = 1;

#if defined(_POSIX_THREAD_PROCESS_SHARED)
	attr->process_shared = PTHREAD_PROCESS_PRIVATE;
#endif
#if defined(_POSIX_THREAD_PRIO_PROTECT)
	attr->prio_ceiling = 0;
	attr->protocol = PTHREAD_PRIO_INHERIT;
#endif
#if defined(_UNIX98_THREAD_MUTEX_ATTRIBUTES)
	attr->type = PTHREAD_MUTEX_DEFAULT;
#endif

	attr->recursive = 0;
	return 0;
}

int pthread_mutexattr_destroy(pthread_mutexattr_t *attr)
{
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	attr->is_initialized = 0;
	return 0;
}
