#include <pthread.h>
#include <errno.h>


int pthread_mutexattr_setprotocol(pthread_mutexattr_t *attr,
    int protocol)
{
#if defined(_POSIX_THREAD_PRIO_PROTECT)
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	if (protocol != PTHREAD_PRIO_NONE &&
		protocol != PTHREAD_PRIO_INHERIT &&
		protocol != PTHREAD_PRIO_PROTECT)
	{
		errno = EINVAL;
		return EINVAL;
	}

	attr->protocol = PTHREAD_PRIO_INHERIT;
#endif
	return 0;
}

int pthread_mutexattr_getprotocol(const pthread_mutexattr_t *attr,
    int *protocol)
{
#if defined(_POSIX_THREAD_PRIO_PROTECT)
	if (attr == NULL || protocol == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	*protocol = attr->protocol;
#endif
	return 0;
}
