#include <pthread.h>
#include <errno.h>


int pthread_mutexattr_getpshared(const pthread_mutexattr_t *attr,
    int *pshared)
{
#if defined(_POSIX_THREAD_PROCESS_SHARED)
	if (attr == NULL || pshared == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	*pshared = attr->process_shared;
#endif
	return 0;
}

int pthread_mutexattr_setpshared(pthread_mutexattr_t *attr,
    int pshared)
{
#if defined(_POSIX_THREAD_PROCESS_SHARED)
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	if (pshared != PTHREAD_PROCESS_SHARED &&
		pshared != PTHREAD_PROCESS_PRIVATE)
	{
		errno = EINVAL;
		return EINVAL;
	}

	attr->process_shared = pshared;
#endif
	return 0;
}
