#include <pthread.h>
#include <errno.h>


int pthread_mutexattr_gettype(const pthread_mutexattr_t *attr, int *type)
{
#if defined(_UNIX98_THREAD_MUTEX_ATTRIBUTES)
	if (attr == NULL || type == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	*type = attr->type;
#endif
	return 0;
}

int pthread_mutexattr_settype(pthread_mutexattr_t *attr, int type)
{
#if defined(_UNIX98_THREAD_MUTEX_ATTRIBUTES)
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	if (type != PTHREAD_MUTEX_NORMAL &&
		type != PTHREAD_MUTEX_RECURSIVE &&
		type != PTHREAD_MUTEX_ERRORCHECK &&
		type != PTHREAD_MUTEX_DEFAULT)
	{
		errno = EINVAL;
		return EINVAL;
	}

	attr->type = type;
#endif
	return 0;
}
