#include <pthread.h>
#include <errno.h>

#include "../debug.h"
#include "pthread_rwlock.h"


int pthread_rwlock_unlock(pthread_rwlock_t *rwlock)
{
	if (rwlock == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	pthread_rwlock_internal_t *internal = pthread_rwlock_internal_find(rwlock);
	if (internal == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	pthread_mutex_lock(&(internal->lock_obj));
	if (internal->writer == pthread_self()) {

		internal->writer = PTHREAD_RWLOCK_OWNER_NOBODY;
		if (pthread_cond_broadcast(&(internal->lock_cond)) != 0) {
			warn("bug");
		}

	} else {

		internal->reads_released++;

		if (internal->reads_acquired == internal->reads_released) {
			pthread_cond_broadcast(&(internal->lock_cond));
		}
	}
	pthread_mutex_unlock(&(internal->lock_obj));

	return 0;
}
