#include <pthread.h>
#include <errno.h>

int pthread_rwlockattr_init(pthread_rwlockattr_t *attr)
{
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

#if defined(_POSIX_THREAD_PROCESS_SHARED)
	attr->process_shared = PTHREAD_PROCESS_PRIVATE;
#endif
	attr->is_initialized = 1;

	return 0;
}
int pthread_rwlockattr_destroy(pthread_rwlockattr_t *attr)
{
	if (attr == NULL) {
		errno = EINVAL;
		return EINVAL;
	}

	attr->is_initialized = 0;
	return 0;
}
