#include <pthread.h>
#include <assert.h>

#include "shmac/shmac.h"

#include "../sched/sched.h"
#include "../core_tq.h"
#include "../boot.h"

pthread_t pthread_self(void)
{
    task_t *job = core_tq_get_current();

    // if job == NULL, then the main core tried to do something before
    // it has been turned into a thread; in which case we'll do that
    // here.
    if (job == NULL) {
        boot_pthreads();

        job = core_tq_get_current();
        assert(job != NULL);
    }

    return *(job->thread);
}
