#include <pthread.h>
#include <errno.h>
#include <assert.h>

#include "../boot.h"
#include "../core_tq.h"


int pthread_setcancelstate(int state, int *oldstate)
{
	task_t *me = core_tq_get_current();
	if (me == NULL) {
		boot_pthreads();
		me = core_tq_get_current();
		assert(me != NULL);
	}

	*oldstate = me->cancel_state;

	if (state == PTHREAD_CANCEL_DISABLE ||
			state == PTHREAD_CANCEL_ENABLE) {
		me->cancel_state = state;
	} else {
		errno = EINVAL;
		return EINVAL;
	}

	return 0;
}
