#include <pthread.h>
#include <errno.h>
#include <assert.h>

#include "../boot.h"
#include "../core_tq.h"


int pthread_setcanceltype(int type, int *oldtype)
{
	task_t *me = core_tq_get_current();
	if (me == NULL) {
		boot_pthreads();
		me = core_tq_get_current();
		assert(me != NULL);
	}

	*oldtype = me->cancel_type;

	if (me->cancel_type == PTHREAD_CANCEL_DEFERRED ||
			me->cancel_type == PTHREAD_CANCEL_ASYNCHRONOUS) {
		me->cancel_type = type;
	} else {
		errno = EINVAL;
		return EINVAL;
	}

	return 0;
}
