#include <stdio.h>
#include <string.h>

#include "shmac/shmac.h"

#include "test.h"
#include "rb_tree.h"
#include "linked_list.h"
#include "ring_buffer.h"
#include "heap.h"
#include "pthreads_threading.h"
#include "pthreads_emb.h"
#include "pthreads_misc.h"


struct test_item {
	const char *heading;
	int (*function)();
};

static struct test_item tests[] = {
	//{
		//.heading = "Binary Heap",
		//.function = &test_heap_all
	//},
	//{
		//.heading = "Doubly-Linked List",
		//.function = &test_linkedlist_all
	//},
	//{
		//.heading = "Red-Black Tree",
		//.function = &test_rbtree_all
	//},
	//{
		//.heading = "Ptheads Threading",
		//.function = &test_pthreads_threading_all
	//},
	{
		.heading = "Pthreads Embedded tests",
		.function = &test_pthreads_embedded_all
	},
	//{
		//.heading = "Ptheads Miscellaneous",
		//.function = &test_pthreads_misc_all
	//},
	//{
		//.heading = "Ring Buffer",
		//.function = &test_ring_buffer_all
	//}
};


void heading(const char *text) {
	int len = strlen(text);

	int l = (HEADING_WIDTH - len - 2) / 2;
	int r = HEADING_WIDTH - len - l - 2;

	printf("\n\n");
	for (int i = 0; i < HEADING_WIDTH; i++) putChar('=');
	printf("\n");

	for (int i = 0; i < l; i++) putChar('=');
	printf(" %s ", text);
	fflush(stdout);
	for (int i = 0; i < r; i++) putChar('=');

	printf("\n");
	for (int i = 0; i < HEADING_WIDTH; i++) putChar('=');
	printf("\n");
}

int run_all_tests()
{
	int ok = 1;
	for (int i = 0; i < sizeof(tests) / sizeof(tests[0]); i++) {
		heading(tests[i].heading);
		ok &= tests[i].function();
	}

	return ok;
}

int main()
{
	*IC0_IRQ_ENABLESET = INT_MASK_HOST;

	printf("Running tests...");
	int ok = run_all_tests();
	printf("\nFinished running tests!\n");

	return ok ? 0 : 1;
}
